void RBufferInitialize(RBUFFER *buffer, WORD size)
{
  buffer->pending = buffer->available = buffer->readoffset = buffer->writeoffset = 0;
  buffer->free = buffer->size = size;
}

void RBufferWrite(RBUFFER *buffer, BYTE d)
{
//  ToggleScheduler();
//  asm("l98: bra l98");
//  ToggleScheduler();

  while(buffer->free == 0)
    BreakAndCooperate();
  buffer->free--;
  buffer->data[buffer->writeoffset] = d;
  if((buffer->writeoffset++) > buffer->size)
    buffer->writeoffset = 0;
  buffer->available++;
}

BYTE RBufferRead(RBUFFER *buffer)
{
  BYTE d;

  while(buffer->available == 0)
    BreakAndCooperate();
  buffer->available--;
  d = buffer->data[buffer->readoffset];
  if((buffer->readoffset++) > buffer->size)
    buffer->readoffset = 0;
  buffer->free++;
  return(d);
}

